; -----------------------------------------------------------------------------
; RetroForth for FreeBSD     | This port was originally written by:
; http://www.retroforth.org  | * Jens *
; -----------------------------------------------------------------------------

include "macros.fasm"

;---------------------------------------------------------------------
; Macros & Constants specific to FreeBSD
stdin  = 0
stdout = 1
stderr = 2

sys_exit   =     0x01
sys_read   =     0x03
sys_write  =     0x04
sys_open   =     0x05
sys_close  =     0x06
sys_mprotect =   0x4a

macro system A {
    push 0x0
    mov eax, A
    int 0x80
    add esp, 4
}

macro sys.exit A {
    push dword A
    system sys_exit
}

format elf executable
entry _start
	public _start
_start:
	call init_retroforth
	call interpret
;---------------------------------------------------------------------
code 'emit', emit
	push eax, ebx, ecx, edx
        mov [buffer], eax       ; Put top of datastack in buffer
        push 0x01               ; Number of characters to write
        push buffer             ; The address of the buffer
        push stdout             ; Write to stdout
        system sys_write
        add esp, 3*4
        pop eax, ebx, ecx, edx
	drop
	ret
code 'key', key
	dup
	push ebx, ecx, edx
        push 0x01               ; Number of characters to read
        push buffer             ; The address of the buffer
        push stdin              ; Read from stdin
        system sys_read
        add esp, 3*4
	pop ebx, ecx, edx
	mov eax, [buffer]       ; Put read character on top of dstack
       	ret
;---------------------------------------------------------------------
code 'bye',freebsd_bye
	sys.exit 0x00

include "retroforth.asm"
